(function (undefined) {function removeArrayItem (array,index) {return array.slice(0,index).concat(array.slice(index + 1));}
function Interval (start,end) {this._start=start;this._end=end;}
Interval.prototype.valueOf=function(){return [this._start, this._end];};
Interval.prototype.start=function(){return this._start;};
Interval.prototype.end=function(){return this._end;};
function Intervals (initial) {this._intervals=initial || [];}
Intervals.prototype.valueOf=function(){var values = [];for(var i=0, l=this._intervals.length;i<l; ++i){values.push(this._intervals[i].valueOf());}
return values;};
Intervals.prototype._mergeOverlappingIntervals=function (list) {list=list.slice(0).sort(function (a,b) {return a.start() - b.start();});
var i, l;var founded=false;var exit=list.length;while(--exit){for (i=0, l=list.length-1;i<l; ++i) {founded=list[i].end() >= list[i+1].start();if(founded){break;}}if(!founded){break;}
founded=false;list[i] = new Interval(list[i].start(), list[i+1].end());list=removeArrayItem(list,i+1);}
return list;}
Intervals.prototype.add=function (interval) {this._intervals.push(new Interval(interval.start(), interval.end()));this._intervals=this._mergeOverlappingIntervals(this._intervals);};
Intervals.prototype.isInclude=function (interval) {for(var i=0, l=this._intervals.length;i<l; ++i){if(interval.start() >= this._intervals[i].start() &&
interval.end() <= this._intervals[i].end()) {return true;}}
return false;};
Intervals.prototype.sub=function (interval) {if(this.isInclude(interval)){return new Intervals();}if(!this._intervals.length){return new Intervals([new Interval(interval.start(), interval.end())]);}
var start=interval.start();var end=interval.end();if(end <= this._intervals[0].start() ||
start >= this._intervals[this._intervals.length-1].end()){return new Intervals([new Interval(start,end)]);}
var i, l;var last;var firstIntervalIndex=0;var lastIntervalIndex=this._intervals.length-1;var result = [];last=this._intervals[0].start();for(i=0, l=this._intervals.length;i<l; ++i){if(start >= last && start <= this._intervals[i].end()) {firstIntervalIndex=i;break;}
last=this._intervals[i].end();}
last=this._intervals[this._intervals.length-1].end();for(i=this._intervals.length-1, l=0-1;i>l; --i){if(end >= this._intervals[i].start() && end <= last) {lastIntervalIndex=i;break;}
last=this._intervals[i].start();}if(lastIntervalIndex < firstIntervalIndex){return new Intervals([new Interval(start,end)]);}if(this._intervals[firstIntervalIndex].start() > start){result.push(new Interval(start, this._intervals[firstIntervalIndex].start()));}
for(var i=firstIntervalIndex, l=lastIntervalIndex;i<l; ++i){result.push(new Interval(
this._intervals[i].end(), this._intervals[i+1].start()
));}if(this._intervals[lastIntervalIndex].end() < end){result.push(new Interval(this._intervals[lastIntervalIndex].end(),end));}
return new Intervals(result);};
Intervals.prototype.toArray=function(){return this._intervals.slice(0);};
this.Interval=Interval;this.Intervals=Intervals;}).call(this);(function (undefined) {this.Program=Backbone.Model.extend({MINIMAL_PROGRAM_DURATION: 60,
defaults: {name: 'unknown',
start_time: 0,
duration: 0,
subname: '',
description: '',
short_desc: '',
image: '',
episode_number: '',
season_number: '',
categories: '',
actors: '',
directors: '',
writers: '',
producers: '',
guests: '',
year: '',
stars_max_number: 0,
stars_number: 0,
is_hdtv: false,
is_repeat: false,
is_premiere: false,
is_record: false,
is_series: false,
is_repeat_record: false,
is_conflicting: false,
is_active: false,
recording_id: '',
schedule_id: '',
is_movie: false,
is_sports: false,
is_news: false,
is_kids: false,
is_special: false,
recommendation: null},
isUnknown: function(){return this.get('name') === this.defaults.name;}});this.Programs=Backbone.Collection.extend({model: Program,
comparator: function (item) {return item.get('start_time');},

getByTime: function (time) {time = +time;return this.find(function (program) {var startTime = +program.get('start_time');var duration = +program.get('duration');return time >= startTime && startTime + duration > time;});},
merge: function (programs,s,e) {var firstProgram=programs.first();var lastProgram=programs.last();var start=s || null;var end=e || null;var existsFirstProgram=this.first();var existsLastProgram=this.last();if(existsFirstProgram && existsLastProgram){start=Math.min(existsFirstProgram.get('start_time'), start);end=Math.max(existsLastProgram.get('start_time') + existsLastProgram.get('duration'), end);}
this.remove(_.filter(this.models, function (program) {return program.isUnknown();}));
this.add(programs.models);this.correctHoleInPrograms(start,end);return this;},

correctHoleInPrograms: function (startLineTime,endLineTime) {var firstProgram=_.first(this.models);var lastProgram=_.last(this.models);if(!firstProgram && !lastProgram){this.add(new this.model({'start_time': startLineTime,
'duration': endLineTime - startLineTime,
'program_id': _.uniqueId('unknown_')}), {at: 0});return;}
var firstProgramStartTime=firstProgram.get('start_time');var lastProgramEndTime=lastProgram.get('start_time') + lastProgram.get('duration');if(startLineTime && firstProgramStartTime > startLineTime){this.add(new this.model({'start_time': startLineTime,
'duration': firstProgramStartTime - startLineTime,
'program_id': _.uniqueId('unknown_')}), {at: 0});}if(endLineTime && lastProgramEndTime < endLineTime){this.add(new this.model({'start_time': lastProgramEndTime,
'duration': endLineTime - lastProgramEndTime,
'program_id': _.uniqueId('unknown_')}), {at: this.length});}
this.remove(_.filter(this.models, function (program) {return program.get('duration') < program.MINIMAL_PROGRAM_DURATION;}));
var program, nextProgram, currentProgramStart, currentProgramEnd, nextProgramStart;var correctProgramList = [];var removeProgramList = [];for(var i=0, l=this.models.length-1;i<l; ++i){program=this.models[i];nextProgram=this.models[i+1];currentProgramStart=Number(program.get('start_time'));currentProgramEnd=Number(currentProgramStart) + Number(program.get('duration'));nextProgramStart=Number(nextProgram.get('start_time'));if(currentProgramEnd !== nextProgramStart){if(currentProgramEnd > nextProgramStart) {if(program.get('program_id') === nextProgram.get('program_id')){removeProgramList.push(this.models[i]);continue;}
this.models[i].set('duration', nextProgramStart-currentProgramStart);if(startLineTime && startLineTime >= nextProgramStart){removeProgramList.push(this.models[i]);}}else{correctProgramList.push({'index': i+1,
'start_time': currentProgramEnd,
'duration': nextProgramStart-currentProgramEnd,
'program_id': _.uniqueId('unknown_')});}}}if(!!removeProgramList.length){_.each(removeProgramList,function (program) {this.remove(program);}, this);}
var index;_.each(correctProgramList,function (program) {index=program.index;delete program.index;this.add(new this.model(program), {at: index});}, this);return this;}});this.CurrentProgram=Backbone.Model.extend({defaults: {program: new Program()}});this.SelectedProgram=Backbone.Model.extend();this.SelectedPrograms=Backbone.Collection.extend({model: SelectedProgram,
clear: function(){var programs=this.map(function (selected) {return selected.get('program');});
_.each(programs,function (program) {program.set('selected', false);});},
deletePastSelection: function (now) {var selectedList=this.filter(function (selected) {var program=selected.get('program');var start=program.get('start_time');var end=start + program.get('duration');end=moment.unix(end);return end.isBefore(now) || end.isSame(now);});
_.each(selectedList,function (selected) {selected.get('program').set('selected', false);});}});}).call(this);(function (undefined) {this.Channel=Backbone.Model.extend({initialize: function(){this.set('programs', new Programs());}});this.Channels=Backbone.Collection.extend({model: Channel,
url: 'channels',
initialize: function (models,options) {options=options || {};this.request=options.request || {};this.startTime=options.startTime;this._emptyResponseChannels = {};this._intervals=new Intervals();this.ready=_.once(_.bind(function(){this.trigger('ready');}, this));this.bind('reset', function(){var start=this.startTime.unix();this._emptyResponseChannels=_.object(this.map(function (ch) {return [ch.get('id'), []];}));
this.requiredInterval3(start, 1, 'right');}, this);},
requiredInterval3: function (start,lineDuration,direction,success) {success=success || function(){};var end=start + lineDuration * 60;if(this._intervals.isInclude(new Interval(start,end))){success();return this;}
var now=moment().unix();var requirededIntervals=this._intervals.sub(new Interval(start,end)).valueOf();var requirededFirstInterval=_.first(requirededIntervals);var requirededLastInterval=_.last(requirededIntervals);if(direction === 'neutral'){requirededFirstInterval[0] = Math.max(start - 60 * 60 * 6, now);requirededLastInterval[1] = requirededFirstInterval[0] + (lineDuration * 60) + (60 * 60 * 12);}else if(direction === 'right'){requirededLastInterval[1] = requirededFirstInterval[0] + (60 * 60 * 12);}else if(direction === 'left'){requirededFirstInterval[0] = Math.max(start - 60 * 60 * 12, now);}else{throw new Error('Invalid param');}
this._requestEPG2(requirededIntervals.valueOf(), _.bind(function (response) {_.each(response,function (item) {var start=item.interval[0];var end=item.interval[1];var channels=_.extend(
_.clone(this._emptyResponseChannels),
_.object(_.map(item.channels, function (channel) {return [channel.cid, channel.programs];}))
);channels=_.map(channels,function (value,key) {return {cid: key, programs: value};});
this._updatePrograms(channels,start,end);this._intervals.add(new Interval(start,end));}, this);this.ready();
this.request.success.apply(this,arguments);success();}, this));return this;},
_requestEPG2: function (intervals,success) {this.request.started();$.ajax({url: 'programs',
type: 'POST',
data: {intervals: JSON.stringify(intervals)},
success: _.bind(function (response) {success(response);}, this),
error: _.bind(function(){this.request.error.apply(this,arguments);}, this)});},
_updatePrograms: function (responseChannels,start,end) {_.each(responseChannels,function (responseChannel) {var channel=this.findWhere({id: responseChannel.cid});channel.get('programs')
.merge(new Programs(responseChannel.programs), start, end)}, this);}});}).call(this);var GuideTable;$(function(){GuideTable=Backbone.View.extend({className: 'table',
template: $('#tvguide-table-tmpl').html(),
events: {'click .programs-line > li > a': 'click'},
click: function (event) {this.$('li.current').removeClass('current');var programElement = $(event.target).closest('li');var pid=programElement.attr('id');var cid=programElement.parent().closest('li').attr('id');this._selectChannel(cid);
var currentProgramsLine=this._getCurrentProgramsLine();currentProgramsLine._selectProgram(pid);
this._changedSelectedProgram();this._lastMoveProgram=currentProgramsLine.getSelectedProgram();return false;},
initialize: function (options) {this.$el.html(this.template);this.channelListElement=this.$('.channel-list ul');this.programsListElement=this.$('.programs-list ul');this.startTime=options.startTime;this.currentStartTime=this.startTime;this._lastWindowOffset=0;var mockItem = $('<div/>').addClass('tvguide-content-mock-item')
.append($('<div/>').addClass('tvguide-content-mock-item-content'))
.appendTo('body');this.itemHeightOuter=mockItem.outerHeight(true);mockItem.remove();
this.numChannelOnScreen=1;function updateTable(){this.endTime=moment.unix(
_.max(_.map(this.model.models, function (channel) {var lastProgram=_.last(channel.get('programs').models);return lastProgram.get('start_time') + lastProgram.get('duration');}, this))
);this.window=_.last(_.first(
this.model.models, this._lastWindowOffset || this.numChannelOnScreen
), this.numChannelOnScreen);this.render();}
this.model.bind('updated sort', updateTable, this);function resizeTable(){var HEADER_FOOTER_HEIGHT=200;var MULT=10;var PADDINGS=3;var MIN_CHANNELS_NUM=2;this.tableHeight = $(window).height() - HEADER_FOOTER_HEIGHT;this.numChannelOnScreen=Math.max(
Math.floor(this.tableHeight / this.itemHeightOuter),
MIN_CHANNELS_NUM
);var $programList = $('.programs-list');$programList.css({width: 'auto'});var width=Math.floor($programList.width() / MULT) * MULT;$programList.width(width - PADDINGS);(this.numChannelOnScreen > 2 ? $.fn.addClass : $.fn.removeClass)
.call($('body'), 'no-vert-scroll')
updateTable.call(this);}
$(window).on('resize.app', _.bind(function(){resizeTable.call(this);}, this));this.programsList = [];this._selectedChannelIndex=0;this._lastMoveProgram=null;this.currentChannel=new Channel({});this.$scrollbar=new SimpleScrollbar();this.$scrollbar.reset();},
remove: function(){$(window).off('resize.app');Backbone.View.prototype.remove.call(this);},
render: function(){this.channelListElement.empty();this.programsListElement.empty();
this.programsList = [];var name;_.each(this.window, function (channel) {name=channel.get('name');var $a = $('<a href="#">')
.addClass('ui-state-default ui-corner-all')
.attr('title', name)
.text(name);var channelNumber=makeChannelNumber(
channel.get('number'), channel.get('subNumber')
);if(channelNumber !== ''){$a.append(
$('<span>')
.addClass('number')
.text(channelNumber));}
this.channelListElement.append(
$('<li>')
.attr('id', channel.get('id'))
.attr('extid', channel.get('extid'))
.addClass(channel.get('childLock') ? 'locked' : '')
.append($a)
);var li = $('<li>').attr('id', channel.get('id'));this.programsListElement.append(li);
var programsLine=new ProgramsLine({model: channel.get('programs'),
parent: li,
lineStartTime: this.startTime,
lineEndTime: this.endTime,
currentStartTime: this.currentStartTime});this.programsList.push(programsLine);
li.append(programsLine.render().el);}, this);this.$el.append(this.$scrollbar.render().el);if(this._lastSelectedProgram){var pid=this._lastSelectedProgram.get('program_id');var currentProgramsLine=this._getCurrentProgramsLine();currentProgramsLine._selectProgram(pid);}
return this;},
moveChannelCursor: function (num) {$('li.current', this.$el).removeClass('current');var currentChannelId=this._seekSelectedChannel(num).get('id');var windowOffset=this._selectedChannelIndex < this.model.models.indexOf(_.first(this.window)) ?
this.numChannelOnScreen : this._selectedChannelIndex > this.model.models.indexOf(_.last(this.window)) ?
1 : 0;if(windowOffset){this._lastWindowOffset=this._selectedChannelIndex + windowOffset;this.window=_.last(_.first(
this.model.models, this._lastWindowOffset
), this.numChannelOnScreen);this.render();}
var currentProgramsLine=this._getCurrentProgramsLine();if(this._lastMoveProgram){var lastSelectedProgramStartTime=this._lastMoveProgram.get('start_time');currentProgramsLine.selectByTime(lastSelectedProgramStartTime);}else{currentProgramsLine.selectByIndex(0);}
$('li#'+currentChannelId, this.channelListElement).addClass('current');this._changedSelectedProgram();
var currentElementIndex=this._selectedChannelIndex;var elementOnPage=this.numChannelOnScreen;var totalElements=this.model.length;this.$scrollbar.update(currentElementIndex,elementOnPage,totalElements);},
pageDown: function(){this.moveChannelCursor(this.numChannelOnScreen-1);},
pageUp: function(){this.moveChannelCursor(-this.numChannelOnScreen+1);},
_getCurrentProgramsLine: function(){var currentChannel=this._getSelectedChannel();var currentChannelPrograms=currentChannel.get('programs');return _.find(this.programsList, function (programsLine) {return programsLine.model === currentChannelPrograms;}, this);},
moveProgramCursor: function (num) {this.moveProgram({right: 'moveCursorRight', left: 'moveCursorLeft'}, num);},
moveProgramPage: function (num) {this.moveProgram({right: 'movePageRight', left: 'movePageLeft'}, num);},
moveProgram: function (funcs,num) {var currentProgramsLine=this._getCurrentProgramsLine();var params=num > 0 ? [funcs.right, 1] : [funcs.left, -1];var time=currentProgramsLine[params[0]].call(
currentProgramsLine, params[1] * num * 60
);var dataReady = $.Deferred();if(time){this.model.requiredInterval3(
time.unix(),
currentProgramsLine.lineDuration,
num > 0 ? 'right' : 'left',
function(){dataReady.resolve();}
);}else{dataReady.resolve();}
dataReady.done(_.bind(function(){currentProgramsLine.move();currentProgramsLine.highlightSelectedProgram();if(time){_.each(this.programsList, function (programsLine) {if(currentProgramsLine!=programsLine){programsLine.move(time);}}, this);this.trigger('change:starttime', time, currentProgramsLine.lineDuration);this.currentStartTime=time;}
this._changedSelectedProgram();this._lastMoveProgram=currentProgramsLine.getSelectedProgram();}, this));},
moveToCurrentTime: function(){var currentProgramsLine=this._getCurrentProgramsLine();var now=moment();_.each(this.programsList, function (programsLine) {programsLine.move(now);}, this);this.trigger('change:starttime', now, currentProgramsLine.lineDuration);this.currentStartTime=now;this._changedSelectedProgram();
this._lastMoveProgram=currentProgramsLine.getSelectedProgram();},
gotoTime: function (time) {var currentProgramsLine=this._getCurrentProgramsLine();this.model.requiredInterval3(time.unix(), currentProgramsLine.lineDuration, 'neutral', _.bind(function(){_.each(this.programsList, function (programsLine) {programsLine.move(time);}, this);this.trigger('change:starttime', time, currentProgramsLine.lineDuration);this.currentStartTime=time;this._changedSelectedProgram();
this._lastMoveProgram=currentProgramsLine.getSelectedProgram();}, this));},
_getSelectedChannel: function(){return this.model.models[this._selectedChannelIndex];},
_seekSelectedChannel: function (num) {this._selectedChannelIndex+=num;this._selectedChannelIndex=Math.max(this._selectedChannelIndex, 0);this._selectedChannelIndex=Math.min(
this._selectedChannelIndex, this.model.models.length-1);return this.model.models[this._selectedChannelIndex];},
_changedSelectedProgram: function(){this.currentChannel.set(this._getSelectedChannel().toJSON());var currentProgramLine=this._getCurrentProgramsLine();if(!currentProgramLine){return;}
var selectedProgram=currentProgramLine.getSelectedProgram();if(selectedProgram === this._lastSelectedProgram){return;}
this._lastSelectedProgram=selectedProgram;this.trigger('change:program', this._lastSelectedProgram);},
changeStartTime: function (time) {this.trigger('beforechange:starttime', time);var currentProgramsLine=this._getCurrentProgramsLine();var rebuilded=_.any(_.map(this.programsList, function (program) {return program.changeStartTime(time, program === currentProgramsLine);}, this));this.startTime=time;if(rebuilded){this.currentStartTime=time;this.trigger('change:starttime', time, currentProgramsLine.lineDuration);this._changedSelectedProgram();}},
_selectChannel: function (cid) {var currentChannel=_.find(this.model.models, function (channel) {return channel.id === cid;}, this);this._selectedChannelIndex=_.indexOf(this.model.models, currentChannel);}});});var ProgramDialog;$(function(){ProgramDialog=Backbone.View.extend({template: _.template($('#program-dialog-tmpl').html()),
initialize: function (options) {this.model.bind('change', function(){this.model.get('program').bind('change', function(){this.render();}, this);this.render();if(this.$dialog.dialog('isOpen')){this.hide();this.show();}}, this);this.$dialog=this.$el.dialog({autoOpen: false,
modal: true,
draggable: true,
resizable: false,
closeText: '',
width: 800,
dialogClass: 'program-dialog-wrapper'});this.channel=options.channel;this.channels=options.channels;this.$channelNumber = $('<span class="channel-number ui-widget ui-widget-content ui-corner-all"></span>')
.prependTo($('.program-dialog-wrapper .ui-dialog-titlebar'));this.$programSelector = $('<input type="checkbox" />').appendTo(
$('<span class="program-selector ui-widget ui-widget-content ui-corner-all" />')
.prependTo($('.program-dialog-wrapper .ui-dialog-titlebar'))
).change(_.bind(function (event) {var $checkbox = $(event.currentTarget);this.model.get('program').set('selected', $checkbox.prop('checked'));}, this));this.channel.bind('change', this.changeChannel, this);},
render: function(){var program;var currentProgram=this.model.get('program');if(currentProgram.get('name') === currentProgram.defaults.name){program=new Program({is_unknown: true,
name: locale.connect.unknown,
start_time: '',
end_time: '',
program_start_date: null,
today_date: null}).toJSON();}else{program=currentProgram.toJSON();var start=moment.unix(program.start_time);program.is_unknown=false;program.start_time=start.format('HH:mm');program.program_start_date=start.format('DD.MM');program.today_date=moment().format('DD.MM');program.end_time=start.add('seconds', program.duration).format('HH:mm');_.each(['categories', 'actors', 'directors', 'writers', 'producers', 'guests'], function (field) {if(!program[field]){return;}
program[field] = program[field].split('/').join(', ');});
program.duration=Math.ceil(program.duration / 60);var dialogWrapper = $('.program-dialog-wrapper');dialogWrapper.removeClass('genre ' + getGenres().join(' '));var genres=getGenres(this.model);if(genres.length){dialogWrapper.addClass('genre');_.each(genres,function (genre) {dialogWrapper.addClass(genre);});}
this.$programSelector.prop('checked', !!currentProgram.get('selected'));}
var now=moment().unix();var programStart=currentProgram.get('start_time');program.now = (now >= programStart && now < programStart + currentProgram.get('duration'));this.$dialog.html(this.template(program));
window.setTimeout(_.bind(function(){if(program.is_unknown){$(this.el).addClass('hidden');}else{$(this.el).removeClass('hidden');}}, this));this.appendButton();
return this;},
changeChannel: function(){this.$dialog.dialog('option', 'title', this.channel.get('name'));this.$channelNumber.text(
makeChannelNumber(
this.channel.get('number'),
this.channel.get('subNumber')
)
);},
show: function(){this.$dialog.dialog('open');},
hide: function(){this.$dialog.dialog('close');},
setPositionOf: function (selector) {this.$dialog.dialog('option', {position: {of: selector}});},
appendButton: function(){var self=this;function processRecord(action,cid,param){$('#progress').dialog('open');var data = $.extend({}, param, {cid: cid, full: true});$.ajax({type: 'POST',
url: '/recordings/' + action + '/',
data: data,
success: function (resp) {var currentProgramElementId = $('.programs-line li.current').attr('id');var currentProgram=self.model.get('program');_.each(self.channels.models, function (channel) {var programs=channel.get('programs');var recorded_programs=programs.where({is_record: true});if(recorded_programs){_.each(recorded_programs,function (program) {program.set({'is_record': false,
'is_active': false,
'is_conflicting': false,
'is_record': false,
'is_repeat_record': false,
'recording_id': '',
'schedule_id': ''});if(channel.get('id') === self.channel.get('id') &&
program.get('program_id') === currentProgram.get('program_id')){self.model.set(program.toJSON());}});}});_.each(resp,function (record) {var channel=self.channels.findWhere({id: record.channel_id});var program=channel.get('programs').findWhere({program_id: record.program_id});if(!program){return;}
program.set({is_active: record.is_active,
is_conflicting: record.is_conflicting,
is_record: record.is_record,
is_repeat_record: record.is_repeat_record,
recording_id: record.recording_id,
schedule_id: record.schedule_id});if(record.channel_id === self.channel.get('id') &&
record.program_id === currentProgram.get('program_id')){self.model.set(program.toJSON());}});$('.programs-line li#' + currentProgramElementId).addClass('current');},
error: function (xhr) {showInfo(xhr.responseText || l.c.internal_error);},
complete: function(){$('#progress').dialog('close');}});}
var currentProgram=self.model.get('program');$('.rec-btn', this.$dialog)
.button({icons: {primary: 'ui-icon-radio-on'},
text: false})
.click(function (e) {e.stopPropagation();var cid=self.channel.get('id');if(currentProgram.get('is_record')){var rid=currentProgram.get('recording_id');processRecord('remove', cid, {rid: rid});}else{var pid=currentProgram.get('program_id');processRecord('add', cid, {pid: pid, repeat: 0});}});$('.rec-ser-btn', this.$dialog)
.button({icons: {primary: 'ui-icon-radio-on',
secondary: 'ui-icon-radio-on'},
text: false,})
.click(function (e) {e.stopPropagation();var cid=self.channel.get('id');if(currentProgram.get('is_repeat_record')){var sid=currentProgram.get('schedule_id');processRecord('remove', cid, {sid: sid});}else{var pid=currentProgram.get('program_id');processRecord('add', cid, {pid: pid, repeat: 1});}});$('.social-share-btn', this.$dialog)
.button({icons: {primary: 'ui-icon-comment'},
text: false})
.click(function (e) {e.stopPropagation();var socialMenu=new SocialMenu();socialMenu.show($(this).closest('.share-wrapper'), {startTimeStamp: currentProgram.get('start_time'),
programName: currentProgram.get('name'),
subname: currentProgram.get('subname'),
channelName: self.channel.get('name')});});
$('.play-btn', this.$dialog)
.button({icons: {primary: 'ui-icon-play'},
text: false})
.click(function (e) {e.stopPropagation();var cid=self.channel.get('extid');var locked=self.channel.get('childLock');watchChannel(cid,locked);self.hide();});plugin('tvguide', 'appendDialogButton', this, [currentProgram, this.channel]);}});});var ProgramsLine;$(function(){ProgramsLine=Backbone.View.extend({tagName: 'ul',
className: 'programs-line nav nav-list clearfix',
PIXELS_INTO_MINUTE: 5,
BORDER_WIDTH: 1,
PADDING: 5,
events: {'change .program-selector input': '_changeProgramSelect'},
_changeProgramSelect: function (event) {var $checkbox = $(event.currentTarget);var programId = $checkbox.closest('li').attr('id');var currentProgram=this.model.findWhere({program_id: programId});currentProgram.set('selected', $checkbox.prop('checked'));this.trigger('program-select', $checkbox.prop('checked'), currentProgram);},
changeStartTime: function (time,isSelectedLine) {var selectedProgram;if(isSelectedLine){selectedProgram=this.getSelectedProgram();}
this.lineStartTime=time;var needRebuild=time.isAfter(this.lineTimeBounds.start);if(needRebuild){this.currentStartTime=time;}
var newFirstProgram=this.model.getByTime(time.unix());var index=this.model.indexOf(newFirstProgram);if(this.selectedProgram > 0){this.selectedProgram-=index;}if(needRebuild){this.render();if(isSelectedLine) {var programStartTime=moment.unix(selectedProgram.get('start_time'));var programEndTime=moment(programStartTime).add(
'minutes', selectedProgram.get('duration') / 60
);if(!programEndTime.isAfter(this.lineTimeBounds.start)){this.selectByTime(this.lineTimeBounds.start.unix());}else{this.select(selectedProgram);}}}
return needRebuild;},
initialize: function (options) {this.parent=options.parent;this.lineStartTime=options.lineStartTime;this.lineEndTime=options.lineEndTime;this.currentStartTime=options.currentStartTime;this.lineTimeBounds = {};this.selectedProgram=0;this.lineDuration=0;var firstProgram=this.model.getByTime(this.lineStartTime.unix());var firstProgramIndex=this.model.indexOf(firstProgram);if(firstProgramIndex > 0){this.model.reset(this.model.tail(firstProgramIndex));}
this.model.bind('change', function(){this.currentStartTime=this.lineTimeBounds.start;this.render();}, this);},
render: function(){return this.build(moment(this.currentStartTime));},
highlightSelectedProgram: function(){var id=this.model.models[this.selectedProgram].get('program_id');this.$('li#'+id).addClass('current');
return this;},
move: function (startTime) {if(!startTime){startTime=this.lineTimeBounds.start;}
return this.build(startTime);},
build: function (startTime) {this.$el.empty();var addBaseProgram=_.bind(function (program,classes,width) {var name=program.get('name');if(name === program.defaults.name){name=locale.connect.unknown;}
var anchor = $('<a href="#">')
.attr('title', name)
.text(name)
.addClass(classes.join(' '))
.css({width: width+'px'});var genres=getGenres(program);if(genres.length){anchor.addClass('genre').append($('<span class="genre-line"/>'));_.each(genres,function (genre) {anchor.addClass(genre);});}
var liElement = $('<li>')
.attr('id', program.get('program_id'))
.append(anchor);if(program.get('is_record')){anchor.append($('<span class="record"/>'));liElement.addClass('record');}if(program.get('is_conflicting')){anchor.append($('<span class="conflict"/>'));liElement.addClass('conflict');}
var programSelected=program.get('selected');liElement.append($('<span class="program-selector" />').append(
$('<input type="checkbox" />')
.attr('checked', programSelected)
));if(programSelected){anchor.append($('<span class="selected"/>'));liElement.addClass('selected');}
plugin('tvguide', 'addProgram', this, [program, liElement]);this.$el.append(liElement);}, this);var alignedTime=moment(startTime).startOf('hours');if(startTime.minutes() > 29){alignedTime.minutes(30);}
var firstProgram=this.model.getByTime(startTime.unix());var firstProgramIndex=this.model.indexOf(firstProgram);if(!firstProgram){firstProgramIndex=0;}
var programs=this.model.models;programs=_.tail(programs,firstProgramIndex);firstProgram=_.first(programs);var firstProgramStartTime=moment.unix(firstProgram.get('start_time'));var firstProgramOffset=alignedTime.diff(firstProgramStartTime, 'minutes');this.lineTimeBounds.start=alignedTime;var parentWidth=this.parent.width();var remainderTime=Math.floor(parentWidth / this.PIXELS_INTO_MINUTE);var program, duration, screenDuration, width, classes = [], i, l;this.lineDuration=remainderTime;for(i=0,l=programs.length;i<l && remainderTime > 0;++i){program=programs[i];duration=program.get('duration') / 60;screenDuration=duration;classes = [];if(i === 0){screenDuration-=firstProgramOffset;if(firstProgramOffset > 0){classes.push('lt');}}if(remainderTime-screenDuration >= 0){remainderTime-=screenDuration;}else{screenDuration=remainderTime;remainderTime=0;classes.push('gt');}
width=screenDuration * this.PIXELS_INTO_MINUTE;width=width - this.BORDER_WIDTH - this.PADDING;width=Math.max(width,0);addBaseProgram(program,classes,width);}if(program){this.lineTimeBounds.end=moment.unix(program.get('start_time')).add('minutes', screenDuration);}
return this;},

getSelectedProgram: function(){return this.model.models[this.selectedProgram];},
select: function (program) {this.selectByIndex(this.model.indexOf(program));return program;},
selectByTime: function (time) {time=moment.unix(time);if(time.isBefore(this.lineTimeBounds.start)){time=this.lineTimeBounds.start;}
var program=this.model.getByTime(time.unix()+1);if(!program){this.selectByIndex(0);return false;}
this.select(program);return program;},
selectByIndex: function (index) {if(index < 0){return false;}
this.selectedProgram=index;var program=this.model.models[this.selectedProgram];if(!program){return false;}
this.$('li#'+program.get('program_id'))
.addClass('current');return program;},

_isProgramStartInTimeBounds: function (program) {var programStartTime=moment.unix(program.get('start_time'));return (programStartTime.isSame(this.lineTimeBounds.start) ||
programStartTime.isAfter(this.lineTimeBounds.start)) &&
programStartTime.isBefore(this.lineTimeBounds.end);},

_isProgramEndInTimeBounds: function (program) {var programStartTime=moment.unix(program.get('start_time'));var programEndTime=moment(programStartTime).add(
'minutes', program.get('duration') / 60
);return programEndTime.isBefore(this.lineTimeBounds.end) ||
programEndTime.isSame(this.lineTimeBounds.end);},

_isProgramStartOnStartTimeBounds: function (program) {var programStartTime=moment.unix(program.get('start_time'));return programStartTime.isSame(this.lineTimeBounds.start);},
moveCursorRight: function(){this.$('li.current').removeClass('current');var programs=this.model.models;var program=programs[this.selectedProgram];var newLineTimeBoundsStart=null;if(this._isProgramEndInTimeBounds(program)){if(!this._isProgramStartInTimeBounds(programs[this.selectedProgram+1])) {this.lineTimeBounds.start.add('minutes', 30);this.lineTimeBounds.end.add('minutes', 30);newLineTimeBoundsStart=this.lineTimeBounds.start;}else{}
++this.selectedProgram;}else{this.lineTimeBounds.start.add('minutes', 30);this.lineTimeBounds.end.add('minutes', 30);newLineTimeBoundsStart=this.lineTimeBounds.start;}
return newLineTimeBoundsStart;},
moveCursorLeft: function(){this.$('li.current').removeClass('current');var programs=this.model.models;var program=programs[this.selectedProgram];var newLineTimeBoundsStart=null;var lineStartedBeforeBound=this.lineStartTime.isBefore(this.lineTimeBounds.start);if(this._isProgramStartInTimeBounds(program)){if(this._isProgramStartOnStartTimeBounds(program)) {if(!lineStartedBeforeBound){return null;}
this.lineTimeBounds.start.add('minutes', -30);this.lineTimeBounds.end.add('minutes', -30);newLineTimeBoundsStart=this.lineTimeBounds.start;}else{}if(this.selectedProgram > 0){--this.selectedProgram;}}else{if(!lineStartedBeforeBound){return null;}
this.lineTimeBounds.start.add('minutes', -30);this.lineTimeBounds.end.add('minutes', -30);newLineTimeBoundsStart=this.lineTimeBounds.start;}
return newLineTimeBoundsStart;},
movePageRight: function (duration) {this.$('li.current').removeClass('current');var calcEnd=moment(this.lineTimeBounds.start);calcEnd.add('minutes', this.lineDuration);calcEnd.add('minutes', duration);this.lineTimeBounds.start.add('minutes', duration);this.lineTimeBounds.end.add('minutes', duration);return this.lineTimeBounds.start;},
movePageLeft: function (duration) {this.$('li.current').removeClass('current');var newLineTimeBoundsStart=null;var calcStart=moment(this.lineTimeBounds.start);calcStart.add('minutes', -1 * duration).add('minutes', 30);if(calcStart.isBefore(this.lineStartTime)){duration = (this.lineTimeBounds.start.unix() - this.lineStartTime.unix()) / 60;}
this.lineTimeBounds.start.add('minutes', -1 * duration);this.lineTimeBounds.end.add('minutes', -1 * duration);return this.lineTimeBounds.start;},
_selectProgram: function (pid) {var currentProgram=_.find(this.model.models, function (program) {return program.get('program_id') === pid;}, this);if(!currentProgram){return;}
this.selectedProgram=_.indexOf(this.model.models, currentProgram);this.highlightSelectedProgram();}});});var TVGrid;$(function(){TVGrid=Backbone.View.extend({className: 'grid',
UPDATE_INTERVAL: 1000,
initialize: function (options) {this.startTime=options.startTime;this.timeline=new Timeline({startTime: this.startTime});this.table=new GuideTable({model: this.model,
startTime: this.startTime})
.bind('change:starttime', this.changeStartTime, this)
.bind('change:program', this.changeProgram, this);this.modelReady=false;this.model.bind('ready', function(){this.modelReady=true;}, this);this._lastUpdate=0;},
remove: function(){this.table.remove();Backbone.View.prototype.remove.call(this);},
render: function(){this.$el.append(this.timeline.render().el);this.$el.append(this.table.render().el);
return this;},
changeStartTime: function (startTime) {this.timeline.moveTo(startTime);},
changeProgram: function (program) {this.trigger('change:program', program);},
updateTimerStart: function(){if(!this._updateTimer){this._updateTimer=window.setInterval(_.bind(function(){if(!this.modelReady){return;}
var now=moment().seconds(0);if(this._lastUpdate === now.unix()){return;}
this.table.changeStartTime(now);this._lastUpdate=now.unix();}, this), this.UPDATE_INTERVAL);}},
updateTimerStop: function(){if(this._updateTimer){window.clearInterval(this._updateTimer);this._updateTimer=false;}}});});var TVGuide;$(function(){TVGuide=Backbone.View.extend({className: 'tvguide-content',
initialize: function(){this.startTime=moment();this.busy=false;var tvguide=this;this.channels=new Channels([], {startTime: this.startTime,
request: {started: function(){tvguide.busy=true;$('#progress').dialog('open');},
success: function (response) {var intervals=_.map(response,function (item) {return {start: item.interval[0],
end: item.interval[1]};});
tvguide.trigger('programs:updated', intervals);tvguide.busy=false;$('#progress').dialog('close');},
error: function(){$('#progress').dialog('close');$('#info-dialog #info-message')
.html(l.c.internal_error);$('#info-dialog').dialog('open');}}});this.tvgrid=new TVGrid({model: this.channels,
startTime: this.startTime})
.bind('change:program', this.changeProgram, this);this.currentProgram=new CurrentProgram();this.selectedPrograms=new SelectedPrograms();this.tvgrid.$el.hide();
this.channels.bind('ready', function(){this.tvgrid.$el.show();this.trigger('ready');
this.channels.each(function (channel) {channel.get('programs').bind('change:selected', function (program,checked) {var selectedProgramInfo = {program: program,
channel: channel};if(checked){this.selectedPrograms.add(selectedProgramInfo);}else{this.selectedPrograms.remove(
this.selectedPrograms.findWhere(selectedProgramInfo));}}, this);}, this);}, this);this.channels.fetch({reset: true,
error: function(){$('#progress').dialog('close');$('#info-dialog #info-message')
.html(l.c.internal_error);$('#info-dialog').dialog('open');}});this.tvgrid.updateTimerStart();
this.tvgrid.table.on('beforechange:starttime', _.bind(function (time) {this.selectedPrograms.deletePastSelection(time);}, this));},
remove: function(){this.tvgrid.remove();Backbone.View.prototype.remove.call(this);},
render: function(){this.$el
.append(this.tvgrid.render().el);return this;},
changeProgram: function (program) {this.currentProgram.set('program', program);},
changeComparator: function(sortField) {this.channels.comparator=function(a,b) {var a=a.get(sortField), b=b.get(sortField);if(typeof a === 'number' && typeof b === 'number'){return a < 0 ? Infinity : (b < 0 ? -Infinity : a - b);}
return a.toLowerCase() < b.toLowerCase() ? -1 : 1;};},
sortChannels: function (sortField) {this.changeComparator(sortField);this.channels.sort();}});});(function (undefined) {this.makeChannelNumber=function (number,subnumber) {return (
(number > -1) ? (
(subnumber > 0) ?
(number + '.' + subnumber) :
('' + number)
) :
'');}
var GENRES=['movie', 'sports', 'news', 'kids', 'special'];this.getGenres=function (program) {if(!program){return GENRES.slice(0);}
return _.filter(GENRES,function (genre) {return program.get('is_'+genre);});}}).call(this);var SimpleScrollbar, Timeline, GotoPopup;$(function(){SimpleScrollbar=Backbone.View.extend({className: 'scrollbar',
initialize: function(){this.$bit = $('<div class="bit"></div>').appendTo(this.$el);this._hideTimer=null;},
render: function(){this.$el.append();return this;},
reset: function(){this.$el.addClass('hidden');this.$bit.css({height: 0,
top: 0});},
update: function (currentElementIndex,elementOnPage,totalElements) {this.$el.removeClass('slow');if(this._hideTimer){window.clearTimeout(this._hideTimer);this._hideTimer=null;}
var multiplier=elementOnPage / totalElements;if(multiplier < 1){var height=this.$el.height();var bitHeight=height * multiplier;var bitOffset = (height - bitHeight) / (totalElements - 1) * currentElementIndex;this.$bit.css({height: bitHeight,
top: bitOffset});this.$el.removeClass('hidden');}else{this.$el.addClass('hidden');}
this._hideTimer=window.setTimeout(_.bind(function(){this.$el.addClass('hidden slow');this._hideTimer=null;}, this), 1000);}});Timeline=Backbone.View.extend({className: 'timeline',
template: '<span class="date"/><ul class="time inline"></ul>',
DATE_FORMAT_STRING: 'D MMMM',
initialize: function (options) {this.$el.html(this.template);this.$time=this.$('.time');this.$date=this.$('.date');this.startTime=options.startTime;this.lastStartTime=0;$(window).on('resize.app', _.bind(function(){this.render();if(this.lastStartTime){this.moveTo(this.lastStartTime);}}, this));},
render: function(){var next=moment(this.startTime).startOf('hours');if(this.startTime.minutes() > 29){next.minutes(30);}
this.$time.empty();this.addTimestamp(this.startTime.format('LT'));
var timelineWidth=this.$time.width();var oneTickWidth=this.$time.find('li').width();if(oneTickWidth >= timelineWidth){return this;}
var MAX_TICK_TEXT_WIDTH=70;var RIGHT_PADDING=15;timelineWidth-=RIGHT_PADDING;var tickNum=Math.floor(timelineWidth / oneTickWidth);if(tickNum * oneTickWidth + MAX_TICK_TEXT_WIDTH < timelineWidth){++tickNum;}
for(var i=0;i<tickNum-1; ++i){this.addTimestamp(next.add('minutes', 30).format('LT'));}
this.updateDateField(this.startTime);this.$time.find('.timestamp:last-child').css({width: 'auto'});return this;},
addTimestamp: function (label) {this.$time.append('<li class="timestamp">'+label+'</li>');},
moveTo: function (startTime) {var now=moment();if(startTime.isBefore(now)){startTime=now;}
var timestampElements=this.$time.find('.timestamp');var alignedTime=moment(startTime).startOf('hours');if(startTime.minutes() > 29){alignedTime.minutes(30);}
$(_.first(timestampElements)).text(startTime.format('LT'));_.each(_.tail(timestampElements,1),function (el) {$(el).text(alignedTime.add('minutes', 30).format('LT'));});
this.updateDateField(startTime);this.lastStartTime=startTime;},
updateDateField: function (startTime) {this.$date.text(startTime.format(this.DATE_FORMAT_STRING));}});GotoPopup=Backbone.View.extend({template: $('#goto-popup-tmpl').html(),
initialize: function (options) {$(document).bind('mousedown.gotopopup', _.bind(function (event) {this.hide();}, this));this.nowCallback=options.nowCallback;this.gotoCallback=options.gotoCallback;},
render: function(){this.$el
.append(
$(this.template)
.bind('mousedown', function (event) {event.stopPropagation();})
.bind('click', function (event) {event.stopPropagation();})
);var currentDate=moment();var $timePicker=this.$('.timepicker').timepicker({showPeriodLabels: false,
onHourShow: function (hour) {var t=moment(currentDate);t.set('hour', hour);t.set('minutes', 59);if(moment().isAfter(t)){return false;}
return true;},
onMinuteShow: function (hour,minute) {var t=moment(currentDate);t.set('hour', hour);t.set('minutes', minute);if(moment().isAfter(t)){return false;}
return true;},
hourText: l.connect.hour,
minuteText: l.connect.minutes});var $datePicker=this.$('.datepicker').datepicker({dateFormat: 'dd.mm.yy',
firstDay: 1,
minDate: '0d',
maxDate: '+2w',
dayNamesMin: l.connect.week,
monthNames: l.connect.months,
onSelect: function(){currentDate=moment($datePicker.datepicker('getDate'));$timePicker.timepicker('refresh');}});this.$('button').button();
this.$('.now-btn').click(_.bind(function(){this.nowCallback();this.hide();
return false;}, this));this.$('.goto-btn').click(_.bind(function(){var gotoDateTime=moment($datePicker.datepicker('getDate'));var time = $timePicker.timepicker('getTimeAsDate');gotoDateTime.set('hour', time.getHours());gotoDateTime.set('minute', time.getMinutes());gotoDateTime.set('second', time.getSeconds());this.gotoCallback(moment.max(moment(),gotoDateTime));this.hide();
return false;}, this));return this;},
hide: function(){this.$('.goto-popup').remove();$(document).unbind('mousedown.gotopopup');}});});$(function(){$('#progress').dialog('open');moment.lang(INTERFACE_LANGUAGE);
var searchInputFocused=false;function watchChannel(cid,locked){var disableTranscoding =
$.cookie('dt') === 'true' || isIEOnWin7();var playback=PLAYBACK_SUPPORTED && !disableTranscoding;var url = '/watch/'+cid+'/';url+=playback ? '?iframe' : '?transcoding=false';if(locked){showParentDialog(url,playback);}else{openProgramPreview(url,playback);}}
function addMousewhell(tvguide,tvguideElement){tvguideElement.on('mousewheel', function(event) {window.setTimeout(function(){tvguide.tvgrid.table.moveChannelCursor(event.deltaY < 0 ? 1 : -1);});
event.stopPropagation();event.preventDefault();});}
function addSwipe(tvguide,tvguideElement){tvguideElement.hammer({prevent_default: true,
no_mouseevents: true}).on('swiperight', function(){tvguide.tvgrid.table.moveProgramPage(-1);}).on('swipeleft', function(){tvguide.tvgrid.table.moveProgramPage(1);}).on('swipeup', function(){tvguide.tvgrid.table.pageDown();}).on('swipedown', function(){tvguide.tvgrid.table.pageUp();});}
function addProgramDialog(tvguide,programsListElement){var programDialog=new ProgramDialog({model: tvguide.currentProgram,
el: $('.program-dialog'),
channel: tvguide.tvgrid.table.currentChannel,
channels: tvguide.channels});programDialog.setPositionOf(programsListElement);
$('.nav-stacked', programsListElement)
.on('click', 'a', function(event) {programDialog.show();});
$('body').on('click', '.ui-widget-overlay', function(){if(programDialog.$dialog.dialog('isOpen')){programDialog.hide();}});return programDialog;}
function addKeyboardHandler(tvguide,programDialog){var Keys = {enter: 13,
pageUp: 33,
pageDown: 34,
left: 37,
up: 38,
right: 39,
down: 40};$('body').on('keydown', function (event) {if(tvguide.busy || searchInputFocused){return;}
window.setTimeout(function(){if(tvguide.busy || searchInputFocused){return;}
var keyCode=event.keyCode;switch (keyCode) {case Keys.down: {tvguide.tvgrid.table.moveChannelCursor(1);break;}
case Keys.up: {tvguide.tvgrid.table.moveChannelCursor(-1);break;}
case Keys.left: {tvguide.tvgrid.table.moveProgramCursor(-1);break;}
case Keys.right: {tvguide.tvgrid.table.moveProgramCursor(1);break;}
case Keys.pageDown: {tvguide.tvgrid.table.pageDown();break;}
case Keys.pageUp: {tvguide.tvgrid.table.pageUp();break;}
case Keys.enter: {programDialog.show();break;}}});});}
function addWatch(channelListElement){channelListElement.on('click', 'li', function(event) {var element = $(this);var cid=element.attr('extid');var locked=element.hasClass('locked');watchChannel(cid,locked);});}
function addControls(tvguide,programsListElement){function showGotoPopup(btn) {var gotoPopup=new GotoPopup({el: $(btn),
nowCallback: function(){tvguide.tvgrid.table.moveToCurrentTime();},
gotoCallback: function (time) {tvguide.tvgrid.table.gotoTime(time);}});gotoPopup.render();}
var controls = {'carat-1-e': {className: 'next-programs horizontal', func: function(){tvguide.tvgrid.table.moveProgramPage(1);}},
'carat-1-w': {className: 'prev-programs horizontal', func: function(){tvguide.tvgrid.table.moveProgramPage(-1);}},
'triangle-1-e': {className: 'next-programs fast horizontal', func: function(){tvguide.tvgrid.table.moveProgramPage(12);}},
'triangle-1-w': {className: 'prev-programs fast horizontal', func: function(){tvguide.tvgrid.table.moveProgramPage(-12);}},
'clock': {className: 'goto fast horizontal', func: function(){showGotoPopup(this);}},
'carat-1-s': {className: 'next-channels vertical', func: function(){tvguide.tvgrid.table.pageDown();}},
'carat-1-n': {className: 'prev-channels vertical', func: function(){tvguide.tvgrid.table.pageUp();}}};_.each(controls,function (desc,direction) {$('<div>')
.addClass('ui-state-default ui-corner-all tvgrid-controls ' + desc.className)
.append($('<span>').addClass('ui-icon ui-icon-' + direction))
.click(function (event) {desc.func.call(this);return false;})
.appendTo(programsListElement);});}
function createHandlers(tvguide){var tvguideElement=tvguide.$el;var programsListElement = $('.programs-list', tvguideElement);var channelListElement = $('.channel-list', tvguideElement);addMousewhell(tvguide,tvguideElement);var programDialog=addProgramDialog(tvguide,programsListElement);addKeyboardHandler(tvguide,programDialog);addWatch(channelListElement);
addControls(tvguide,programsListElement);return programDialog;}
function createSortPanel(){$('.sort-panel').buttonset();$('.sort-panel').on('mouseout', '.on', function(){window.setTimeout(function () {$('.sort-panel .on').addClass('ui-state-active');});});$('.sort-panel button').click(function(){$('.sort-panel .ui-state-active').removeClass('ui-state-active');$('.sort-panel .on').removeClass('on');var sortBy = $(this).attr('id').split('sort-by-')[1];tvguide.sortChannels(sortBy);
$.cookie('tvguidesort', sortBy, {expires: COOKIE_EXPIRES,
path: COOKIE_PATH});$(this).addClass('on');
window.setTimeout(function(){$('.sort-panel .on').addClass('ui-state-active');});
return false;});
var DEFAULT_SORT = 'name';var sortBy = $.cookie('tvguidesort') || DEFAULT_SORT;$('.sort-panel button#sort-by-' + sortBy).addClass('ui-state-active on');tvguide.sortChannels(sortBy);}
function createSearchPanel(){$('#search-btn').button({icons: {primary: 'ui-icon-search'},
disabled: true});$('.genres-place').hover(function(){$(this).addClass('open');}, function(){$(this).removeClass('open');});
$('.genres-list :checkbox')
.prop('checked', false)
.change(function(){updateSubmitButtonState();});
$('.genres-place .show-btn').button({icons: {primary: 'ui-icon-grip-solid-horizontal'},
text: false,
disabled: false});$('select#search-channel').selectmenu();
$('input#search-query')
.val(SEARCH_TEXT)
.addClass('default')
.focus(function(){if($(this).val()==SEARCH_TEXT){$(this).val('');$(this).removeClass('default');}
searchInputFocused=true;})
.blur(function(){if($(this).val()==''){$(this).val(SEARCH_TEXT);$(this).addClass('default');}
searchInputFocused=false;})
.keyup(function(){updateSubmitButtonState();});
$('#search-frm')
.submit(function(){if(test_search_query()){$('#progress').dialog('open');if($('input#search-query').val() === SEARCH_TEXT) {$('input#search-query').val('');}
return true;}
return false;});
function test_search_query(){var sq = $('input#search-query').val();var selectedGenres = $('.genres-list :checkbox:checked').length > 0;return (sq != SEARCH_TEXT && (sq.length > 3-1)) || selectedGenres;}
function updateSubmitButtonState(){$('#search-btn').button('option', 'disabled', !test_search_query());}}
$.fn.fancybox.defaults.width=wwidth();$.fn.fancybox.defaults.height=wheight();var tvguide=new TVGuide();window.tvguide=tvguide;tvguide.bind('ready', function(){var programDialog=createHandlers(this);$('#progress').dialog('close');
$(window).trigger('resize.app');var searchChannelCombobox = $('select#search-channel');_.each(this.channels.models, function (channel) {$('<option/>')
.val(channel.get('id'))
.text(channel.get('name'))
.attr('title', channel.get('name'))
.appendTo(searchChannelCombobox);});
searchChannelCombobox.selectmenu();plugin('tvguide', 'ready', this, [programDialog]);});
tvguide.render();$('.main-content').html(tvguide.el);
createSearchPanel();createSortPanel();
plugin('tvguide', 'enter', this, [tvguide]);});